﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParallelFor
{
    class Program
    {
        private static double obliczenia(double argument)
        {
            for(int i = 0; i < 10; ++i)
            {
                argument = Math.Asin(Math.Sin(argument));
            }
            return argument;
        }

        static void Main1(string[] args)
        {
            //przygotowania
            int rozmiar = 100000;
            Random r = new Random();
            double[] tablica = new double[rozmiar];
            for (int i = 0; i < tablica.Length; ++i)
                tablica[i] = r.NextDouble();

            //obliczenia sekwencyjne
            int liczbaPowtórzeń = 100;
            double[] wyniki = new double[tablica.Length];
            int start = Environment.TickCount;
            for (int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; ++powtórzenia)
                for (int i = 0; i < tablica.Length; ++i) //<--------------------
                    wyniki[i] = obliczenia(tablica[i]);
            int stop = Environment.TickCount;
            int czasObliczeńSekwencyjnychMs = stop - start;
            Console.WriteLine("Obliczenia sekwencyjne trwały " + czasObliczeńSekwencyjnychMs.ToString() + " ms.");

            //obliczenia równoległe
            start = Environment.TickCount;
            for (int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; ++powtórzenia)
                Parallel.For(0, tablica.Length, (int i) => { wyniki[i] = obliczenia(tablica[i]); });
                //for (int i = 0; i < tablica.Length; ++i)
                  //  wyniki[i] = obliczenia(tablica[i]);
            stop = Environment.TickCount;
            int czasObliczeńRównoległychMs = stop - start;
            Console.WriteLine("Obliczenia równoległe trwały " + czasObliczeńRównoległychMs.ToString() + " ms.");

            double przyspieszenie = 1.0 * czasObliczeńSekwencyjnychMs / czasObliczeńRównoległychMs;
            Console.WriteLine("Przyspieszenie: " + przyspieszenie);

            //prezentacje wyników
            //TBA
        }

        static void Main(string[] args)
        {
            Random r = new Random();
            long suma = 0;
            long licznik = 0;
            string s = "";

            Parallel.For(0, 10000, (int i, ParallelLoopState stanPętli) =>
            {
                int liczba = r.Next(7);
                if(liczba == 0)
                {
                    s += "Stop:";
                    stanPętli.Stop();
                }
                if (stanPętli.IsStopped) return;
                if (liczba % 2 == 0)
                {
                    s += liczba.ToString() + ": ";
                    obliczenia(liczba);
                    suma += liczba;
                    licznik++;
                }
                else s += "[" + liczba.ToString() + "]: ";
            });

            Console.WriteLine("Wylosowane liczby: " + s);
        }
    }
}
